package com.mikecouturier.tews;

// @todo, clean code

import org.mortbay.jetty.servlet.Context;
import org.mortbay.jetty.servlet.ServletHolder;

import java.util.*;

public class Servers {
    private static Map<Integer, org.mortbay.jetty.Server> runningServers = new HashMap<Integer, org.mortbay.jetty.Server>();

    public static void start(int port) throws Exception {
        start(new UrlSpecificationList(), port);
    }

    public static void start(UrlSpecificationList urlSpecificationList, int port) throws Exception {
        org.mortbay.jetty.Server server = new org.mortbay.jetty.Server(port);
        List<UrlSpecification> urls = urlSpecificationList.getList();

        Context defaultContext = new Context(server, "/");
        for (int i = 0; i < urls.size(); i++) {
            UrlSpecification url = urls.get(i);
            defaultContext.addServlet(new ServletHolder(new PathHandler(url)), url.getPath());
        }

        server.start();
        runningServers.put(port, server);
    }

    public static void stop(int port) throws Exception {
        if (!runningServers.containsKey(port)) {
            throw new IllegalStateException("No server running at port: " + port);
        }

        org.mortbay.jetty.Server s = runningServers.remove(port);
        s.stop();
    }

    public static void stopAll() throws Exception {
        for (Integer port : new HashSet<Integer>(runningServers.keySet())) {
            stop(port);
        }
    }
}